from mmtk import *

# Construct system
world = InfiniteUniverse(AmberForceField())
world.protein = Protein('bala1')

# Minimize
minimizer = ConjugateGradientMinimizer(world, log = (0, None, 50, stdout,
						     ("energy",)))
minimizer(convergence = 1.e-3, steps = 10000)

# Calculate normal modes
modes = NormalModes(world)

# Print frequencies
for mode in modes:
    print mode

# Show animation of the first non-trivial mode 
view(modes[6])
