#! /usr/bin/env python

from mmtk import *
from ConfigIO import *
from Positioner import DelaunayTriangulation
import sys

# Load the PDB sequence
sequence = PDBFile(sys.argv[1]).readSequenceWithConfiguration()
# Construct the peptide chain objects
chains = map(PeptideChain, sequence)
# Construct positions of missing hydrogens
for chain in chains:
    chain.findHydrogenPositions()
# Make protein object
molecule = Protein(chains)

delaunay = DelaunayTriangulation(molecule)
delaunay.removeFacesBiggerThan(4*Units.Ang*Units.Ang)

if 1:
    import RasMol
    ras_session = RasMol.RasMol(molecule, 0)
    for i in range(delaunay.numberOfTetrahedra()):
	coords = delaunay.tetrahedronCoordList(i)
	if coords:
	    coords = map(list, coords)
	    ras_session.AddPolygon(coords)
    ras_session.RefreshScreen()
    ras_session.Interact()

