from mmtk import *

# Construct system
world = InfiniteUniverse(AmberForceField())
world.protein = Protein('bala1')

# Transformation to be applied between the steps
transformation = Rotation(Vector(0.,0.,1.), 1.*Units.deg)

# Create trajectory
trajectory = Trajectory(world, "rotation.nc", "w", "A rotating molecule")

# Create the snapshot generator
snapshot = SnapshotGenerator(world,
			     log = None,
			     trajectory = (0, None, 1, trajectory))

# Perform rotations and write the configurations
snapshot()
for i in range(20):
    world.protein.applyTransformation(transformation)
    snapshot()

# Close trajectory
trajectory.close()
