#! /usr/bin/env python

from mmtk import *
import sys

grp = Group(sys.argv[1])

if len(sys.argv) > 2:
    ff = GenericForceField(sys.argv[2])
else:
    ff = AmberForceField()
try:
    grp.setPositions(ff)
except ConformationError, msg:
    grp.printBadDihedrals()
    print 'ConformationError',msg
    try:
	grp.translateTo(Vector(0,0,0))
    except TypeError, msg: print 'TypeError during translateTo',msg
else:
    grp.printBadDihedrals()
    grp.calcDanglingBonds(ff)
    #print 'Dangling Bond Angles:'
    #grp.printDanglingBondAngles()
    print 'Dangling Bonds:'
    grp.printDanglingBonds(0, 1)
    grp.positionDanglingBonds(ff)
    grp.labelDanglingBonds()

import RasMol
ras_session = RasMol.RasMol(grp, 1)
ras_session.RefreshScreen()
ras_session.Interact()
