from mmtk import *
import sys, string

ff = AmberForceField()
world = InfiniteUniverse(ff)
ball_half = Group('buckyball1', configuration = 'default')

tube_length = string.atoi(sys.argv[1])
if tube_length > 0:
    tube_section = Group('buckytube')
    if tube_length == 1:
	tube = tube_section
    else:
	join = Joiner(tube_section)
	join.repeatGroup('hook1', 'hook2', tube_length)
	tube = join.getResult()

join = Joiner(ball_half)
if tube_length > 0:
    join.joinGroups(ball_half.hook2, tube.hook1)
    part1 = join.getIntermediateResult().hook2
else:
    part1 = ball_half.hook2
join.joinGroups(part1, ball_half.hook1)
result = join.getResult()
try:
    result.setPositions(ff)
except ConformationError, msg:
    print 'ConformationError',msg
else:
    world.group = result

    minimizer = ConjugateGradientMinimizer(world, log = (0, None, 50, stdout,
						     ("energy",)))
    minimizer(convergence = 1.e-3, steps = 20)

result.printBadDihedrals()
save(result,'resultb.mmtk')
from ConfigIO import OutputFile
fmt = OutputFile('PDB/resultb.pdb', 'pdb.connect')
fmt.write(result)
fmt.close()

import RasMol
ras_session = RasMol.RasMol(result, 0, 1)
ras_session.Interact()
